##########################################################################
# Remplace une suite de "Trim()" spars par des "++"
# par des enchainements type fondu (syntaxe dissolve)
# - si texte slctionn: c'est ce texte qui est trait
# - sinon: c'est le document entier qui est trait
#    Exemple de selection : Trim(2085, 2310) ++ Trim(2749, 3016)
#    --> remplac par     : Dissolve(Trim(2085,2310), Trim(2749,3016), 16)
# Les lignes comportant des caractres non numriques sont ignores !
##########################################################################

import sys, locale

global fps

# Constantes
defnbframes = 16 # Nombre de frames des transition par dfaut
defnbsec = 4 # Nombre de secondes mini par dfaut

# Jeu de caractres par dfaut
reload(sys)
sys.setdefaultencoding(locale.getdefaultlocale()[1])

##########################################
# convTrim
# Convertie une chane de Trim en Dissolve
##########################################
def convTrim(s, nbf, nbs):
	global fps
	newcmd = ''
	nbdissolve = 0
	nbframesmini = int(nbs * fps)

	splittrim = s.split('++')
	if len(splittrim) <= 1:
		return ""

	for i in splittrim:
		i2 = str(i.lower().strip())
		isagoodtrimseq = 0

		# Vrifie que la syntaxe du trim est bonne
		if i2.startswith('trim(') and i2.endswith(')'):
			strtrimlist = i2[5:len(i2)-1].split(',')
			if len(strtrimlist) == 2:
				frame1 = strtrimlist[0].strip()
				frame2 = strtrimlist[1].strip()
				if (not frame1.isdigit()) or (not frame2.isdigit()):
					avsp.MsgBox(str(frame1) + str(frame1.isdigit()) + " " + str(frame2) + str(frame2.isdigit()))
					return ""
				frame1 = int(frame1)
				frame2 = int(frame2)
				seqnbframes = frame2 - frame1

				if seqnbframes >= nbframesmini:
					isagoodtrimseq = 1

		# Gnre la nouvelle ligne de trim
		if(isagoodtrimseq):
			if newcmd == '': # commande vide
				newcmd = 'Trim(' + str(frame1) + ',' + str(frame2) + ')'
			elif isagoodtrimseqprev == 0: # trim prcdent invalide
				newcmd += ' ++ Trim(' + str(frame1) + ',' + str(frame2) + ')'
			else: # trim courant et trim prcdent valides
				newcmd += ', Trim(' + str(frame1) + ',' + str(frame2) + ')'
				nbdissolve += 1
		else:
			if newcmd == '':
				newcmd = i2
			else:
				newcmd += ' ++ ' + i2

		isagoodtrimseqprev = isagoodtrimseq
	#end for

	if nbdissolve>0:
		newcmd = 'Dissolve(' + newcmd + ', ' + str(nbf) + ')'

	return newcmd
# end def #############################

# findfps
# Recherche le fps dans le script
# ( amliorer !!!)
def findfps():
	scripttxt = avsp.GetText()
	i=-1
	
	# Recherche d'une occurence de fps
	indexfps = scripttxt.find("fps=")
	if indexfps != -1:
		i = indexfps + 4
	else:
		indexfps = scripttxt.find("fps =")
		if indexfps != -1:
			i = indexfps + 5
	
	# Recherche d'un fps entier ou dcimal
	if indexfps != -1:
		scripttxt = scripttxt[i:len(scripttxt)].strip()
		j=0
		fpsstring = ""
		while (j<len(scripttxt)) and ((scripttxt[j].isdigit()) or (scripttxt[j] == ".")):
			fpsstring += scripttxt[j]
			j+=1
		fpsstring = fpsstring.strip(".")
		if fpsstring:
			if fpsstring.isdigit():
				return int(fpsstring)
			else:
				return float(fpsstring)
	return -1
# end def #############################

# Recherche du fps
fps = findfps()
if fps == -1:
	fps = avsp.GetVideoFramerate()
if float(fps) == int(fps):
	fps = int(fps)

# Paramtres utilisateur
labels = ['Nombre de frames pour les transitions (de 2  80):', 'Dure minimum des squences (gauche / droite)\npour que le fondu soit appliqu (en secondes):']
defaults = [str(defnbframes), str(defnbsec)]
donnees = avsp.GetTextEntry(labels, defaults, 'Paramtres')

if donnees:
	nbframes = donnees[0]
	nbsec = donnees[1]

	if not nbframes.isnumeric() or int(nbframes) < 2 or int(nbframes) > 80:
		avsp.MsgBox('Nombre de frames erron')
	elif not nbsec.isnumeric() or int(nbsec) < 1:
		avsp.MsgBox('Nombre de secondes erron')
	else:
		nbframes = int(nbframes)
		nbsec = int(nbsec)
		line = avsp.GetSelectedText()

		# Convertie les Trim d'une slction
		if line != '':
			endnewcmd = ''

			# Cas d'une slection avec un EOL inclus
			if line.endswith('\n'):
				endnewcmd = '\n'
				line = line.rstrip('\n')

			if line.find('\n') != -1:
				avsp.MsgBox('La slction doit tre sur une seule ligne')
			else:
				if line.lower().startswith('trim('):
					newline = convTrim(line, nbframes, nbsec)
					if newline:
						avsp.InsertText(newline + endnewcmd, pos=None)

		# Convertie les Trim du script entier
		else:
			scriptlines = avsp.GetText().splitlines()
			newscripttxt = ''
			for l in scriptlines:
				if l.lower().strip().startswith('trim('):
					newline = convTrim(l, nbframes, nbsec)
					if newline:
						newscripttxt += '#' + l + '\n' + newline + '\n'
					else:
						newscripttxt += l + '\n'
				else:
					newscripttxt += l + '\n'
			avsp.SetText(newscripttxt)
